package common;

import java.util.Date;

public class Action implements Comparable<Action> {

        public final Integer priority;
        public final Runnable action;
        public final Date executeBefore;
        public final Date executeAfter;
        public Action(int pri, Runnable act, Date aftr, Date bfr){
            executeBefore = bfr;
            executeAfter = aftr;
            priority = pri;
            if (priority==null){
                throw new IllegalStateException("priority cannot be null");
            }
            action = act;
            if (action==null){
                throw new IllegalStateException("action cannot be null");
            }
        }

        public Action(Runnable act, Date aftr, Date bfr){
            this(0,act,aftr,bfr);
        }

        public Action(Runnable act){
            this(0,act,null,null);
        }

        public Action(int pri, Runnable act){
            this(pri,act,null,null);
        }

        public int compareTo(Action o){
            if (o!=null){
                return priority.compareTo(o.priority)*-1;
            } else {
                return 1;
            }
        }
    }

