package common;

/**
 * Created with IntelliJ IDEA.
 * User: Hakara
 * Date: 05/05/13
 * Time: 10:31
 * To change this template use File | Settings | File Templates.
 */

import java.util.*;

public class FastPriorityActionQueue {

    private LinkedList<Action>[] queue;

    private int highestPriorityAdded = 0;

    public FastPriorityActionQueue(int maxPriority){
        queue = new LinkedList[maxPriority];
    }

//    private Object rank1 = new Object();
//    private Object rank2 = new Object();
//    private Object rank3 = new Object();

    // O(1) to add actions
   public synchronized void add(Action a){
       if (a.priority>highestPriorityAdded){
           highestPriorityAdded = a.priority;
       }
        LinkedList<Action> list = queue[a.priority];
        if (list!=null){
            list.add(a);
        } else {
            LinkedList<Action> newList = new LinkedList<Action>();
            newList.add(a);
            queue[a.priority] = newList;
        }
    }

    // O(1) to remove actions
    public synchronized Action remove(){
        Action value = null;
        LinkedList<Action> list = queue[highestPriorityAdded];
        if (list!=null){
            // removes head
            value = list.remove();
        }
        return (Action)value;
    }

    public synchronized Action peek(){
        Action value = null;
        LinkedList<Action> list = queue[highestPriorityAdded];
        if (list!=null){
            // removes head
            value = list.peek();
        }
        return (Action)value;
    }
}
