package test.doorlock;

import org.junit.Before;
import org.junit.After;
import org.junit.Test;

import java.util.concurrent.PriorityBlockingQueue;

import common.Utils;

/**
 * Created with IntelliJ IDEA.
 * User: Hakara
 * Date: 30/04/13
 * Time: 15:37
 * To change this template use File | Settings | File Templates.
 */

import common.*;

public class TestMessageQueueOrdering {

    FastPriorityActionQueue q;

    @Before
    public void before(){
        q = new FastPriorityActionQueue(4);
    }

    @After
    public void after(){
       q = null;
    }


    @Test
    public void testOrderByDate() throws Exception {

         Action m1 = new Action(()->{});
         Utils.waitFor(200);
         Action m2 = new Action(()->{});
         Utils.waitFor(200);
         Action m3 = new Action(()->{});

        q.add(m1);
        q.add(m2);
        q.add(m3);

        assert(q.peek()==m1);
    }

    @Test
    public void testOrderByPriority() throws Exception {
        Action m1 = new Action(3,()->{});
        Action m2 = new Action(2,()->{});
        Action m3 = new Action(1,()->{});

        q.add(m1);
        q.add(m2);
        q.add(m3);

        assert(q.peek()==m1);

    }

    @Test
    public void testOrderByPriorityThenByDate() throws Exception {
        Action m0 = new Action(3,()->{});
        Action m1 = new Action(3,()->{});
        Action m2 = new Action(2,()->{});
        Action m3 = new Action(1,()->{});

        q.add(m0);
        q.add(m1);
        q.add(m2);
        q.add(m3);

        assert(q.peek()==m0);
    }
}
